############################################################
####      Luhmann - R fr Einsteiger - 4. Auflage      #####
#### Kapitel 14 - Varianzanalyse ohne Messwiederholung #####
############################################################


# Beispieldaten laden 
setwd("D:/Ordner 1/Ordner 2")
load("erstis.RData")

attach(erstis)




#### Abschnitt 14.1 ####

# Varianzen in den vier Gruppen 
round(tapply(neuro, gruppe, var, na.rm=TRUE), 2)

# Levene-Test
library(car)
leveneTest(neuro ~ gruppe)

# Varianzanalyse bei Varianzhomogenitt: Modell speichern
anova.1 <- aov(neuro ~ gruppe)

# Varianzanalyse bei Varianzhomogenitt: Deskriptive Statistiken
model.tables(anova.1, "means")

# Varianzanalyse bei Varianzhomogenitt: Ergebnis
summary(anova.1)

# Varianzanalyse bei Varianzheterogenitt
oneway.test(alter ~ wohnort.alt)


#### Abschnitt 14.2  ####

# Zweifaktorielle Varianzanalyse: Orthogonale Kontraste definieren
contrasts(job) <- contr.sum(2)
contrasts(kinder) <- contr.sum(2)

# Zweifaktorielle Varianzanalyse: Modell speichern
anova.2 <- aov(alter ~ job * kinder)

# Zweifaktorielle Varianzanalyse: Deskriptive Statistiken
model.tables(anova.2, "means")

# Zweifaktorielle Varianzanalyse: Ergebnis
library(car)
Anova(anova.2, type = 3)

# Interaktionsdiagramm 
library("phia")
plot(interactionMeans(anova.2))

#### Abschnitt 14.3 ####

# Post-hoc-Verfahren: Bonferroni
pairwise.t.test(alter, wohnort.alt, p.adj="bonferroni")

# Tukey's HSD 
TukeyHSD(anova.2)


#### Abschnitt 14.4 ####

# Ursprngliche Kontraste 
contrasts(wohnort.alt)

# Neue Kontrastmatrix 
neue.kontraste <- cbind(Berlin = c(-1,-1,3,-1), 
			Ausland = c(-1,-1,0,2),
			Lnder = c(-1,1,0,0))
neue.kontraste 

# Neue Kontrastmatrix zuweisen
contrasts(wohnort.alt) <- neue.kontraste

# Modell erneut schtzen und Ergebnisse fr Kontraste ausgeben lassen
anova.3 <- aov(neuro ~ wohnort.alt)

summary(anova.3)
summary.lm(anova.3)



#### Abschnitt 14.5 ####

# Effektgre: Schritte
QS.Effekt <- 580.4
QS.Fehler <- 4937.3
pes <- QS.Effekt/(QS.Effekt + QS.Fehler)
f <- sqrt(pes/(1-pes))
pes
f

# Konfidenzintervall fr partielles eta2
library(MBESS)
ci.pvaf(F.value=19.8654, df.1=1, df.2=169, N=173)



